<?php 
/***************************************************************************

Plugin Name:  Dashboard: Recent Comments Extended
Plugin URI:   http://rick.jinlabs.com/code/dashboard-recent-comments-extended
Description:  Displays recent comments on your WordPress 2.5+ dashboard.
Version:      1.0
Author:       Ricardo Gonz&aacute;lez Castro
Author URI:   http://rick.jinlabs.com/

**************************************************************************/

/***************************************************************************

Inspired in Dashboard: Latest Spam by Viper007Bond
http://www.viper007bond.com/wordpress-plugins/dashboard-latest-spam/

**************************************************************************/

/***************************************************************************

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
The license is also available at http://www.gnu.org/copyleft/gpl.html

**************************************************************************/


class DashboardRecentCommentsExtended {

	// Class initialization
	function DashboardRecentCommentsExtended() {
		// Load up the localization file if we're using WordPress in a different language
		// Place it in this plugin's folder and name it "dashboard-recent-comments-extended-[value in wp-config].mo"
		load_plugin_textdomain( 'dashboard-recent-comments-extended', '/wp-content/plugins/dashboard-recent-comments-extended' );

		// Add the widget to the dashboard
		add_action( 'wp_dashboard_setup',  array(&$this, 'register_widget') );
		add_filter( 'wp_dashboard_widgets', array(&$this, 'add_widget') );
	}


	// Register this widget -- we use a hook/function to make the widget a dashboard-only widget
	function register_widget() {
		if ( !$widget_options = get_option( 'dashboard_widget_options' ) )
			$widget_options = array();

		wp_register_sidebar_widget( 'dashboard_recent_comments_extended', __( 'Recent Comments Extended', 'dashboard-recent-comments-extended' ), array(&$this, 'widget'), array(
		 'all_link' => 'edit-comments.php',
 		 'feed_link' => get_bloginfo('comments_rss2_url'), 
		 'width' => 'half',
		 'height' => 'single' ) );
		wp_register_widget_control( 'dashboard_recent_comments_extended', __( 'Recent Comments Extended', 'dashboard-recent-comments-extended' ), array(&$this, 'widget_control'), array(), array( 'widget_id' => 'dashboard_recent_comments_extended' ) );
	}


	// Modifies the array of dashboard widgets and adds this plugin's
	function add_widget( $widgets ) {
		global $wp_registered_widgets;

		if ( !isset($wp_registered_widgets['dashboard_recent_comments_extended']) ) return $widgets;

		array_splice( $widgets, 0, 0, 'dashboard_recent_comments_extended' );
		return $widgets;
	}


	// Output the widget contents
	function widget( $args ) {
		global $comment, $wpdb;
		extract( $args, EXTR_SKIP );

		echo $before_widget;

		echo $before_title;
		echo $widget_name;
		echo $after_title;

		if ( !$widget_options = get_option( 'dashboard_widget_options' ) )
			$widget_options = array();

		if ( !isset($widget_options[$widget_id]) )
			$widget_options[$widget_id] = array();

		if ( !isset($widget_options[$widget_id]['items']) )
			$widget_options[$widget_id]['items'] = 10;
		if ( !isset($widget_options[$widget_id]['showtime']) )
			$widget_options[$widget_id]['showtime'] = true;
		if ( !isset($widget_options[$widget_id]['postprotected']) )
			$widget_options[$widget_id]['postprotected'] = false;
		if ( !isset($widget_options[$widget_id]['showtrackbacks']) )
			$widget_options[$widget_id]['showtrackbacks'] = false;
		if ( !isset($widget_options[$widget_id]['showexcerpt']) )
			$widget_options[$widget_id]['showexcerpt'] = true;
						
    $request = "SELECT * FROM $wpdb->comments LEFT JOIN $wpdb->posts ON $wpdb->posts.ID=$wpdb->comments.comment_post_ID WHERE post_status IN ('publish','static') ";
	if(!$widget_options[$widget_id]['postprotected']) $request .= "AND post_password ='' ";
	if(!$widget_options[$widget_id]['showtrackbacks']) $request .= "AND comment_type ='' ";
	$request .= "AND comment_approved = '1' ORDER BY comment_ID DESC LIMIT ".$widget_options[$widget_id]['items'];
	$comments = $wpdb->get_results($request);	

		if ( $comments ) {
			echo "				<ul id='dashboard-recent-comments-extended-list'>\n";

			foreach ( $comments as $comment ) {
				$comment_post_url = get_permalink( $comment->comment_post_ID );
				$comment_post_title = get_the_title( $comment->comment_post_ID );
				$comment_post_link = "<a href='$comment_post_url'>$comment_post_title</a>";
				$comment_link = '<a class="comment-link" href="' . get_comment_link() . '">#</a>';
				$comment_meta = sprintf( __( 'From <strong>%1$s</strong> on %2$s %3$s' ), get_comment_author_link(), $comment_post_link, $comment_link );
				
        if($widget_options[$widget_id]['showtime']) {				
          $time = get_comment_time('G', true);

          if ( ( abs(time() - $time) ) < 86400 )
            $h_time = sprintf( __('%s ago'), human_time_diff( $time ) );
          else
            $h_time = mysql2date(__('Y/m/d'), $comment->comment_date);


          $comment_meta.= sprintf( __(' &#8212; %s', 'dashboard-recent-comments-extended'),'<abbr title="' . get_comment_time(__('Y/m/d H:i:s')) . '">' . $h_time . '</abbr>' );
          }
          
?>
					<li class='comment-meta'>
            <?php if ( $widget_options[$widget_id]['showexcerpt'] ) : ?> &#8220;<?php comment_excerpt(); ?>&#8221;<br /><?php endif; ?>
						<?php echo $comment_meta; ?>
					</li>
<?php
			}

			echo "				</ul>\n";
		} else {
				echo '				<p>' . __( "Sorry! You don't have any comments in your database!", 'dashboard-recent-comments-extended' ) . "</p>\n";
		}

		echo $after_widget;
	}


	// Outputs the options view of the widget as well as saves the options on form submit
	function widget_control( $args ) {
		extract( $args );
		if ( !$widget_id )
			return false;

		if ( !$widget_options = get_option( 'dashboard_widget_options' ) )
			$widget_options = array();

		if ( !isset($widget_options[$widget_id]) )
			$widget_options[$widget_id] = array();

		if ( 'POST' == $_SERVER['REQUEST_METHOD'] && isset($_POST['widget-recent-comments-extended']) ) {
			$widget_options[$widget_id] = stripslashes_deep( $_POST['widget-recent-comments-extended'] );

			if ( !isset($widget_options[$widget_id]['items']) )
				$widget_options[$widget_id]['items'] = 5;
			$widget_options[$widget_id]['items'] = (int) $widget_options[$widget_id]['items'];

			if ( !isset($widget_options[$widget_id]['showtime']) )
				$widget_options[$widget_id]['showtime'] = 0;
	
			if ( !isset($widget_options[$widget_id]['postprotected']) )
				$widget_options[$widget_id]['postprotected'] = 0;

			if ( !isset($widget_options[$widget_id]['showexcerpt']) )
				$widget_options[$widget_id]['showexcerpt'] = 0;

			if ( !isset($widget_options[$widget_id]['showtrackbacks']) )
				$widget_options[$widget_id]['showtrackbacks'] = 0;
								
			update_option( 'dashboard_widget_options', $widget_options );
		}

		if ( !isset($widget_options[$widget_id]['items']) )
			$widget_options[$widget_id]['items'] = 5;

		if ( !isset($widget_options[$widget_id]['showtime']) )
			$widget_options[$widget_id]['showtime'] = 1;
			
		if ( !isset($widget_options[$widget_id]['postprotected']) )
			$widget_options[$widget_id]['postprotected'] = 1;

		if ( !isset($widget_options[$widget_id]['showexcerpt']) )
			$widget_options[$widget_id]['showexcerpt'] = 1;

		if ( !isset($widget_options[$widget_id]['showtrackbacks']) )
			$widget_options[$widget_id]['showtrackbacks'] = 1;
?>
	<p>
		<label for="recent-comments-extended-count"><?php _e('How many recent comments would you like to display?', 'dashboard-recent-comments-extended' ); ?>
			<select id="recent-comments-extended-count" name="widget-recent-comments-extended[items]">
				<?php
					for ( $i = 5; $i <= 20; $i = $i + 1 )
						echo "<option value='$i'" . ( $widget_options[$widget_id]['items'] == $i ? " selected='selected'" : '' ) . ">$i</option>";
				?>
			</select>
		</label>
	</p>

   <p>
		<label for="recent-comments-extended-showexcerpt">
			<input id="recent-comments-extended-showexcerpt" name="widget-recent-comments-extended[showexcerpt]" type="checkbox" value="1"<?php if ( 1 == $widget_options[$widget_id]['showexcerpt'] ) echo ' checked="checked"'; ?> />
			<?php _e('Show excerpt?', 'dashboard-recent-comments-extended' ); ?>
		</label>
	</p>

   <p>
		<label for="recent-comments-extended-showtime">
			<input id="recent-comments-extended-showtime" name="widget-recent-comments-extended[showtime]" type="checkbox" value="1"<?php if ( 1 == $widget_options[$widget_id]['showtime'] ) echo ' checked="checked"'; ?> />
			<?php _e('Show comment date?', 'dashboard-recent-comments-extended' ); ?>
		</label>
	</p>
	<p>
		<label for="recent-comments-extended-showtrackbacks">
			<input id="recent-comments-extended-showtrackbacks" name="widget-recent-comments-extended[showtrackbacks]" type="checkbox" value="1"<?php if ( 1 == $widget_options[$widget_id]['showtrackbacks'] ) echo ' checked="checked"'; ?> />
			<?php _e('Show trackbacks/pingbacks?', 'dashboard-recent-comments-extended' ); ?>
		</label>
	</p>
	
  <p>
		<label for="recent-comments-extended-postprotected">
			<input id="recent-comments-extended-postprotected" name="widget-recent-comments-extended[postprotected]" type="checkbox" value="1"<?php if ( 1 == $widget_options[$widget_id]['postprotected'] ) echo ' checked="checked"'; ?> />
			<?php _e('Show comments from password protected posts?', 'dashboard-recent-comments-extended' ); ?>
		</label>
	</p>
	
<?php
	}
}

// Start this plugin once all other plugins are fully loaded
add_action( 'plugins_loaded', create_function( '', 'global $DashboardRecentCommentsExtended; $DashboardRecentCommentsExtended = new DashboardRecentCommentsExtended();' ) );

?>